const express = require('express');
const router = express.Router();
const {
    getTransactions,
    createTransaction,
    deleteTransaction,
    getDashboardData,
    exportTransactions
} = require('../controllers/transactionController');
const { auth, admin } = require('../middleware/auth');

// 所有路由都需要认证
router.use(auth);

// 仪表板数据
router.get('/dashboard', getDashboardData);

// 导出数据
router.get('/export', exportTransactions);

// 交易管理
router.route('/')
    .get(getTransactions)
    .post(createTransaction);

router.route('/:id')
    .delete(admin, deleteTransaction);

module.exports = router; 